<template>
    <div class="app-view-layout app-view-layout__decalendarexpview ibizorder-calendar-exp-view-layout" v-loading="isLayoutLoadding" :style="{height: '100%', width: '100%', overflow: 'auto'}">
        <div v-show="!isLayoutLoadding" :style="{height: '100%', width: '100%'}">
    <app-scroll-container name="container_scroll1" :layoutModelDetails="layoutModelDetails">
        <template #container_scroll_main1>
    <app-scroll-container name="container_scroll_main1" :layoutModelDetails="layoutModelDetails">
        <template #nav_pos1>
        <app-nav-pos name="nav_pos1" :layoutModelDetails="layoutModelDetails" :navData="layoutModelDetails['nav_pos1'].navData"/>
        </template>
    </app-scroll-container>
        </template>
        <template #container_scroll_header1>
    <app-scroll-container name="container_scroll_header1" :layoutModelDetails="layoutModelDetails">
        <template #container_grid1>
    <app-simpleflex-container name="container_grid1" :layoutModelDetails="layoutModelDetails">
        <template #container1>
    <app-simpleflex-container name="container1" :layoutModelDetails="layoutModelDetails">
        <template #view_pagecaption>
        <app-preset-caption name="view_pagecaption" :layoutModelDetails="layoutModelDetails"> 实体日历导航视图 </app-preset-caption>
        </template>
    </app-simpleflex-container>
        </template>
        <template #container2>
    <app-simpleflex-container name="container2" :layoutModelDetails="layoutModelDetails">
    </app-simpleflex-container>
        </template>
    </app-simpleflex-container>
        </template>
    </app-scroll-container>
        </template>
        <template #container_scroll_left1>
    <app-scroll-container name="container_scroll_left1" :layoutModelDetails="layoutModelDetails">
        <template #calendarexpbar>
        <app-ctrl-pos name="calendarexpbar" :layoutModelDetails="layoutModelDetails">
        <view_calendarexpbar 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context"
    :pViewCtx="viewCtx"
    :showBusyIndicator="true" 
    :viewUID="viewUID"
    :newdata="newdata"
    :opendata="opendata"
    name="calendarexpbar"  
    ref='calendarexpbar' 
    @selectionchange="calendarexpbar_selectionchange($event)"  
    @load="calendarexpbar_load($event)"  
    @activated="calendarexpbar_activated($event)"  
    @closeview="closeView($event)">
</view_calendarexpbar>
        </app-ctrl-pos>
        </template>
    </app-scroll-container>
        </template>
    </app-scroll-container>
        </div>
    </div>
</template>
// 基于 @VIEW/实体日历导航视图/VIEW-BASE.vue.ftl 生成
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util } from '@/utils';
import axios from 'axios';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
import { Subject,Subscription } from 'rxjs';
import IBIZOrderService from '@/service/ibizorder/ibizorder-service';
import IBIZOrderAuthService from '@/authservice/ibizorder/ibizorder-auth-service';

import CalendarExpViewEngine from '@engine/view/calendar-exp-view-engine';

import IBIZOrderUIService from '@/uiservice/ibizorder/ibizorder-ui-service';
import { PanelContainerModel, PanelRawitemModel, PanelFieldModel, PanelControlModel, PanelButtonModel, PanelUserControlModel, PanelTabPanelModel, PanelTabPageModel, PanelCtrlPosModel} from '@/model/panel-detail';


@Component({
    components: {
    },
})
export default class IBIZOrderCalendarExpView_layoutBase extends Vue {

    /**
     * 实体服务对象
     *
     * @type {IBIZOrderService}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public appEntityService: IBIZOrderService = new IBIZOrderService();

    /**
     * 实体UI服务对象
     *
     * @type IBIZOrderUIService
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public appUIService: IBIZOrderUIService = new IBIZOrderUIService();
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof IBIZOrderCalendarExpView_layoutBase
	 */
	public viewtag: string = '8a29ee094e2f26c928d26ef24d29401f';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof IBIZOrderCalendarExpView_layoutBase
	 */
	public viewType: string = 'DECALENDAREXPVIEW';

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof IBIZOrderCalendarExpView_layoutBase
	 */
    public customViewNavContexts:any ={
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof IBIZOrderCalendarExpView_layoutBase
	 */
    public customViewParams:any ={
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public model: any = {
        srfCaption: this.$t('MENUITEM.CAPTION.ENTITYCALENDARNAVIGATIONVIEW','实体日历导航视图'),
        srfTitle: '实体日历导航视图',
        srfSubTitle: '',
        dataInfo: ''
    }

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if(newVal){
            this.viewparams = {};
            if(typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            }else{
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            
        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        
        if (!Object.is(newVal, oldVal) && _this.engine) {
            this.$nextTick(()=>{
              _this.parseViewParam();
              _this.engine.load();
            });
        } else if(!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public containerModel: any = {
        view_calendarexpbar: { name: 'calendarexpbar', type: 'CALENDAREXPBAR' },
        wflinks: [],
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public viewCtx: any = {};

    /**
     *  计数器刷新
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public viewState: Subject<ViewState> = new Subject();

    /**
     * 视图布局顶级成员名称
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public rootLayoutDetailNames: string[] = [ 'container_scroll1' ];

    /**
     * 视图布局面板项模型对象
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public layoutItems:any = {
        nav_pos1:{ name: 'nav_pos1', type: 'VIEWLAYOUT', caption: '导航区占位', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'FULL', layoutWidth:0, widthMode:'FULL', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , viewType: 'DECALENDAREXPVIEW', predefinedType: 'NAV_POS', contentType: '', contentStyle: '', rawContent: '', htmlContent: '', },
        container_scroll_main1:{ name: 'container_scroll_main1', type: 'VIEWLAYOUT', caption: '面板容器', titleBarCloseMode: 0, isShowCaption: true, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'BORDER', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll1', panel: this , details:['nav_pos1'] , dataRegionType: 'INHERIT' },
        view_pagecaption:{ name: 'view_pagecaption', type: 'VIEWLAYOUT', caption: '页面标题', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'LEFT', vAlignSelf:'MIDDLE', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'VIEW_PAGECAPTION', renderMode: 'HEADING1', dataItemName:'', wrapMode:'', vAlign:'', hAlign:'', },
        container1:{ name: 'container1', type: 'VIEWLAYOUT', caption: '面板容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'SIMPLEFLEX', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:3, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_grid1', panel: this , details:['view_pagecaption'] , dataRegionType: 'INHERIT' },
        container2:{ name: 'container2', type: 'VIEWLAYOUT', caption: '面板容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'SIMPLEFLEX', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:9, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_grid1', panel: this , details:[] , dataRegionType: 'INHERIT' },
        container_grid1:{ name: 'container_grid1', type: 'VIEWLAYOUT', caption: '栅格容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'SIMPLEFLEX', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_header1', panel: this , details:['container1','container2'] , dataRegionType: 'INHERIT' },
        container_scroll_header1:{ name: 'container_scroll_header1', type: 'VIEWLAYOUT', caption: '面板容器', titleBarCloseMode: 0, isShowCaption: true, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'BORDER', layoutPos:'NORTH', layoutHeight:80, heightMode:'PX', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll1', panel: this , details:['container_grid1'] , dataRegionType: 'INHERIT' },
        calendarexpbar:{ name: 'calendarexpbar', type: 'VIEWLAYOUT', caption: 'CALENDAREXPBAR部件', isShowCaption: true, sysCss: '', itemType: 'CTRLPOS', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'FULL', layoutWidth:0, widthMode:'FULL', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_left1', panel: this },
        container_scroll_left1:{ name: 'container_scroll_left1', type: 'VIEWLAYOUT', caption: '面板容器', titleBarCloseMode: 0, isShowCaption: true, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'BORDER', layoutPos:'WEST', layoutHeight:0, heightMode:'', layoutWidth:20, widthMode:'PERCENTAGE', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll1', panel: this , details:['calendarexpbar'] , dataRegionType: 'INHERIT' },
        container_scroll1:{ name: 'container_scroll1', type: 'VIEWLAYOUT', caption: '滚动条容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'BORDER', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, panel: this , details:['container_scroll_main1','container_scroll_header1','container_scroll_left1'] , dataRegionType: 'INHERIT' }
    }

    /**
     * 布局面板是否加载
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public isLayoutLoadding: boolean = true;

    /**
     * 布局面板数据
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public layoutData:any = {};

    /**
     * 布局面板模型对象
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public layoutModelDetails:any = {};

    /**
     *  初始化布局
     *
     *  @public
     *  @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public async initLayout() {
        if (this.rootLayoutDetailNames.length > 0) {
            for (let i = 0; i < this.rootLayoutDetailNames.length; i++) {
                const name = this.rootLayoutDetailNames[i];
                const rootItem = this.layoutItems[name];
                if (!rootItem) {
                    return;
                }
                await this.initLayoutItem(rootItem);
            }
        }
        return true;
    }

    /**
     *  初始化布局项
     *
     *  @public
     *  @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public async initLayoutItem(layoutModelItem: any, index?: number) {
        const { name } = layoutModelItem;
        const layoutModelDetail = Util.getLayoutItemInstance(layoutModelItem);
        if (!(index || index === 0)) {
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, name, layoutModelDetail);
            this.$set(this.layoutData, name, layoutModelDetail.getData());
        } else {
            layoutModelDetail.setIndex(index);
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, `${name}_${index}`, layoutModelDetail);
            this.$set(this.layoutData, `${name}_${index}`, layoutModelDetail.getData());
        }
        if (layoutModelDetail && layoutModelDetail.details) {
            if (layoutModelDetail.dataRegionType === 'MULTIDATA') {
                const multiData = layoutModelDetail.getData();
                if (multiData && multiData.length > 0) {
                    for (let i = 0; i < multiData.length; i++) {
                        for (let j = 0; j < layoutModelDetail.details.length; j++) {
                            const key = layoutModelDetail.details[j];
                            if (this.layoutItems[key]) {
                                await this.initLayoutItem(this.layoutItems[key], i);
                            }
                        }
                    }
                }
            } else {
                for (let i = 0; i < layoutModelDetail.details.length; i++) {
                    const key = layoutModelDetail.details[i];
                    if (this.layoutItems[key]) {
                        await this.initLayoutItem(this.layoutItems[key], index);
                    }
                }
            }
        }
    }

    /**
     * 计算面板按钮权限状态
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public async computeButtonAuthState() {
        for (const key in this.layoutModelDetails) {
            const layoutModel = this.layoutModelDetails[key];
            if (layoutModel.itemType == 'BUTTON') {
                await layoutModel.computeActionAuthState();
            }
        }
    }

    /**
     * 处理值改变
     *
     * @public
     * @params args 改变数据
     * @params index 多数据容器下标
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public handleValueChange(args: { name: string, value: any }, index?: number) {
        const { name, value } = args;
        let fullName = (index || index === 0) ? `${name}_${index}` : name;
        if (!fullName || !this.layoutData.hasOwnProperty(fullName)) {
            return;
        }
        this.layoutData[fullName] = value;
        this.layoutModelDetails[fullName].setData(value);
        this.panelLogic(name, index);
        this.computeButtonAuthState();
    }


    /**
     * 面板逻辑
     *
     * @public
     * @params name 改变项名称
     * @params index 多数据容器下标
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public panelLogic(name: string, index?: number): void {
    }

    /**
     * 处理按钮点击
     *
     * @public
     * @params name 按钮项名称
     * @params index 多数据容器下标
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public handleButtonClick(name: string, index?: number) {
        let datas: any[] = [];
        let fullName = (index || index === 0) ? `${name}_${index}` : name;
        const data: any = this.layoutModelDetails[fullName].getData();
        if (data) {
            if (data instanceof Array) {
                datas = [...data];
            } else {
                datas = [data];
            }
        }
        const xData: any = this.layoutModelDetails[fullName].getDataArea();
        const paramJO: any = {};
        const contextJO: any = {};
        const _this: any = this;
    }



    /**
     * 视图引擎
     *
     * @public
     * @type {Engine}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public engine: CalendarExpViewEngine = new CalendarExpViewEngine();

    /**
     * 引擎初始化
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public engineInit(): void {
        this.engine.init({
            view: this,
            calendarexpbar: this.$refs.calendarexpbar,
            keyPSDEField: 'ibizorder',
            majorPSDEField: 'ibizordername',
            isLoadDefault: true,
        });
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public  navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof IBIZOrderCalendarExpView_layoutBase
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    @Prop() public portletState?: any;

    /**
     * 门户部件状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public portletStateEvent: Subscription | undefined;

    /**
    * 门户部件状态事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof IBIZOrderCalendarExpView_layoutBase
    */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public viewCacheData:any;


    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 解析视图参数
     *
     * @public
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public parseViewParam(inputvalue:any = null): void {
        for(let key in this.context){
            delete this.context[key];
        }
        if(this.$store.getters.getAppData() && this.$store.getters.getAppData().context){
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        if(inputvalue){
            Object.assign(this.context,{'ibizorder':inputvalue});
        }
        //初始化视图唯一标识
        Object.assign(this.context,{srfsessionid:this.$util.createUUID()});
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
	public handleCustomViewData(){
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'ibizorder-calendar-exp-view-layout',tag:this.viewtag,srfkey:isNew ? null : this.context.ibizorder,title:this.model.srfCaption,data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'ibizorder-calendar-exp-view-layout',tag:this.viewtag,srfkey:this.context.ibizorder,title:this.model.srfCaption,data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	

    /**
     * Vue声明周期
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'ibizorder-calendar-exp-view-layout')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    if(_this.engine){
                        _this.engine.load();
                    }
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'IBIZOrderCalendarExpView_layout')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.formDruipartEvent) {
            _this.formDruipartEvent.unsubscribe();
        }
        if (_this.engine) {
            _this.engine.destroy();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public afterMounted(){
        const _this: any = this;
        _this.initLayout().then((result: any) => {
            _this.isLayoutLoadding = false;
            _this.engineInit();
            if (_this.loadModel && _this.loadModel instanceof Function) {
                _this.loadModel();
            }
        })
    }

    /**
     * calendarexpbar 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public calendarexpbar_selectionchange($event: any, $event2?: any) {
        this.engine.onCtrlEvent('calendarexpbar', 'selectionchange', $event);
    }
    /**
     * calendarexpbar 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public calendarexpbar_load($event: any, $event2?: any) {
        this.engine.onCtrlEvent('calendarexpbar', 'load', $event);
    }
    /**
     * calendarexpbar 部件 activated 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public calendarexpbar_activated($event: any, $event2?: any) {
        this.engine.onCtrlEvent('calendarexpbar', 'activated', $event);
    }


    /**
     * 打开新建数据视图
     *
     * @param {any[]} args
     * @param {*} [params]
     * @param {*} [fullargs]
     * @param {*} [$event]
     * @param {*} [xData]
     * @memberof IBIZOrderCalendarExpView_layout
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        let localContext:any = null;
        let localViewParam:any =null;
        const data: any = {};
        if(args[0].srfsourcekey){
            data.srfsourcekey = args[0].srfsourcekey;
        }
        let tempContext = JSON.parse(JSON.stringify(this.context));
        delete tempContext.ibizorder;
        if(args.length >0){
            Object.assign(tempContext,args[0]);
        }
        const deResParameters: any[] = [];
        const parameters: any[] = [
            { pathName: 'ibizorders', parameterName: 'ibizorder' },
            { pathName: 'editview', parameterName: 'editview' },
        ];
        const _this: any = this;
        const openIndexViewTab = (data: any) => {
            const _data: any = { w: (new Date().getTime()) };
            Object.assign(_data, data);
            const routePath = this.$viewTool.buildUpRoutePath(this.$route, tempContext, deResParameters, parameters, args, _data);
            this.$router.push(routePath);
        }
        openIndexViewTab(data);
    }


    /**
     * 打开编辑数据视图
     *
     * @param {any[]} args
     * @param {*} [params]
     * @param {*} [fullargs]
     * @param {*} [$event]
     * @param {*} [xData]
     * @memberof IBIZOrderCalendarExpView_layout
     */
    public opendata(args: any[],fullargs?:any,params?: any, $event?: any, xData?: any) {
        if(!this.viewDefaultUsage){
            if(Object.is(this.navModel,"route")){
                this.initNavDataWithRoute(this.viewCacheData, false, true);
            }else{
                this.initNavDataWithTab(this.viewCacheData, false, true);
            }
        }
        let localContext:any = null;
        let localViewParam:any =null;
        const data: any = {};
        let tempContext = JSON.parse(JSON.stringify(this.context));
        if(args.length >0){
            Object.assign(tempContext,args[0]);
        }
        const deResParameters: any[] = [];
        const parameters: any[] = [
            { pathName: 'ibizorders', parameterName: 'ibizorder' },
            { pathName: 'editview', parameterName: 'editview' },
        ];
        const _this: any = this;
        if (fullargs && fullargs.length > 0) {
            const _args = fullargs[0];
            if (_args['srfprocessdefinitionkey'] && _args['srftaskdefinitionkey']) {
                Object.assign(data, {
                    processDefinitionKey: _args['srfprocessdefinitionkey'],
                    taskDefinitionKey: _args['srftaskdefinitionkey']
                });
                if (_args['srftaskid']) {
                    Object.assign(data, { 'srftaskid': _args['srftaskid'] });
                }
            }
        }
        if(fullargs && fullargs.copymode){
            Object.assign(data,{copymode:true});
        }
        const openIndexViewTab = (data: any) => {
            const routePath = this.$viewTool.buildUpRoutePath(this.$route, tempContext, deResParameters, parameters, args, data);
            this.$router.push(routePath);
        }
        openIndexViewTab(data);
    }



    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        }
    }

    /**
     * 销毁视图回调
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public destroyed(){
        this.afterDestroyed();
    }

    /**
     * 执行destroyed后的逻辑
     * 
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public afterDestroyed(){
        if (this.viewDefaultUsage) {
                let localStoreLength = Object.keys(localStorage);
                if(localStoreLength.length > 0){
                    localStoreLength.forEach((item:string) =>{
                    if(item.startsWith(this.context.srfsessionid)){
                        localStorage.removeItem(item);
                    }
                    })
                }
                if(Object.is(this.navModel,"tab")){
                    this.navDataService.removeNavDataByTag(this.viewtag);
                }
            }
            // 销毁计数器定时器
            if(this.counterServiceArray && this.counterServiceArray.length >0){
                this.counterServiceArray.forEach((item:any) =>{
                    if(item.destroyCounter && item.destroyCounter instanceof Function){
                        item.destroyCounter();
                    }
                })
            }
    }

    /**
     * 视图唯一标识
     *
     * @type {string}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public viewUID: string = 'sample-ibizorder-calendar-exp-view-layout';

    /**
     * 分隔值
     *
     * @type {number}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public split: number = 0.5;

    /**
     * 导航项
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public navItem: any = {};

    /**
     * split值变化事件
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public onSplitChange() {
        if (this.split) {
            this.$store.commit("setViewSplit", { viewUID: this.viewUID, viewSplit: this.split });
        }
    }

    /**
     * 初始化分隔值
     *
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public initSplit() {
        if (this.$store.getters.getViewSplit(this.viewUID)) {
            this.split = this.$store.getters.getViewSplit(this.viewUID);
        } else {
            const containerWidth = (this.$el as any).offsetWidth;
            this.split = 0 / containerWidth;
            this.$store.commit("setViewSplit", { viewUID: this.viewUID, viewSplit: this.split }); 
        }  
    }

}
</script>

<style lang='less'>
@import './ibizorder-calendar-exp-view-layout.less';
</style>